.DATA

DISPATCHER_CONTEXT struc ; (sizeof=0x50)
        ControlPc        dq ?
        ImageBase        dq ?
        FunctionEntry    dq ?
        EstablisherFrame dq ?
        TargetIp         dq ?
        ContextRecord    dq ?
        LanguageHandler  dq ?
        HandlerData      dq ?
        HistoryTable     dq ?
        ScopeIndex       dd ?
        Fill0            dd ?
DISPATCHER_CONTEXT ends

ExceptionCollidedUnwind equ 0003h

.CODE

;
; Publics
;

PUBLIC RtlpExecuteHandlerForUnwind


RtlpUnwindHandler PROC

        ;
        ; Retrieve DispatcherContext from EstablisherFrame.
        ;
        
        mov      rax, [rdx+20h]

        ;
        ; Copy the old DispatcherContext over the new DispatcherContext.
        ;
        ; N.B. TargetIp is notably not copied over.
        ;
		
        mov      r10, [rax+DISPATCHER_CONTEXT.ControlPc]
        mov      [r9+DISPATCHER_CONTEXT.ControlPc], r10
        mov      r10, [rax+DISPATCHER_CONTEXT.ImageBase]
        mov      [r9+DISPATCHER_CONTEXT.ImageBase], r10
        mov      r10, [rax+DISPATCHER_CONTEXT.FunctionEntry]
        mov      [r9+DISPATCHER_CONTEXT.FunctionEntry], r10
        mov      r10, [rax+DISPATCHER_CONTEXT.EstablisherFrame]
        mov      [r9+DISPATCHER_CONTEXT.EstablisherFrame], r10
        mov      r10, [rax+DISPATCHER_CONTEXT.ContextRecord]
        mov      [r9+DISPATCHER_CONTEXT.ContextRecord], r10
        mov      r10, [rax+DISPATCHER_CONTEXT.LanguageHandler]
        mov      [r9+DISPATCHER_CONTEXT.LanguageHandler], r10
        mov      r10, [rax+DISPATCHER_CONTEXT.HandlerData]
        mov      [r9+DISPATCHER_CONTEXT.HandlerData], r10
        mov      r10, [rax+DISPATCHER_CONTEXT.HistoryTable]
        mov      [r9+DISPATCHER_CONTEXT.HistoryTable], r10
        mov      r10d, [rax+DISPATCHER_CONTEXT.ScopeIndex]
        mov      [r9+DISPATCHER_CONTEXT.ScopeIndex], r10d
        
        ;
        ; Return ExceptionCollidedUnwind.
        ;
        
        mov      eax, ExceptionCollidedUnwind
        ret
RtlpUnwindHandler ENDP

RtlpExecuteHandlerForUnwind PROC FRAME : RtlpUnwindHandler

        .allocstack 28h
        sub      rsp, 28h

        .endprolog

        ;
        ; Save away DispatcherContext, so that the exception handler can
        ; retrieve it if need be.
        ;

        mov      [rsp+20h], r9

        ;
        ; Make the call.
        ;

        call     qword ptr [r9+DISPATCHER_CONTEXT.LanguageHandler]

        ;
        ; Mysterious nop here.  I don't know why the Microsoft version has it,
        ; and this is obviously a function hand-written in assembler.  What's
        ; more is that the nop isn't there on the x86 version of this routine.
        ;

        nop

        ;
        ; Return out.
        ;

		add      esp, 28h
        ret      
RtlpExecuteHandlerForUnwind ENDP

END
